import sys
import random

class Graph:
    def __init__(self, text):
        lines=text.split('\n')
        head=lines[0]
        fld=head.split()
        self.id=int(fld[1])
        self.text=text 
        assert fld[0]=='G'
        self.n=int(lines[1])
        self.nodes={}
        self.edges={}
        self.parse_nodes(lines[2:2+self.n])
        self.parse_edges(lines[2+self.n:])

    def parse_nodes(self, lines):
        for l in lines:
            fld=l.split()
            i=int(fld[0])
            attr=[float(x) for x in fld[1:]]
            self.nodes[i]=attr
            self.edges[i]=set()
            assert len(attr)==4

    def parse_edges(self, lines):
        for l in lines:
            fld=l.split()
            if len(fld)!=2:
                continue
            i=int(fld[0])
            j=int(fld[1])
            self.edges[i].add(j)
            self.edges[j].add(i)



def read_graphs(fname):
    lst=[]
    f=open(fname)
    text=''
    for line in f:
        if line[:1]=='G':
            if text:
                lst.append(Graph(text))
                text=''
        text+=line
    if text:
        lst.append(Graph(text))
    f.close()
    return lst


def compute_prod(graphs):
    lst=[]
    for g1 in graphs:
        for g2 in graphs:
            if g1.id > g2.id:
                continue
            lst.append((g1.id, g2.id, g1.n*g2.n))
    return lst

def write_prod(fname, prod):
    f=open(fname, 'w')
    for id1, id2, p in prod:
        f.write('%d %d %g\n' % (id1, id2, p))
    f.close()

if __name__=='__main__':
    infname=sys.argv[1]
    graphs=read_graphs(infname)
    print 'Graphs read:', len(graphs)
    prod=compute_prod(graphs)
    outfname=sys.argv[2]
    write_prod(outfname, prod)
